"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = installCompiler;
const index_1 = __importDefault(require("../../../resources/index"));
const clean_require_1 = __importDefault(require("../../../utils/clean-require"));
const is_template_valid_1 = __importDefault(require("../../../utils/is-template-valid"));
const npm = __importStar(require("../../../utils/npm-utils"));
async function installCompiler(options) {
    const { compilerPath, componentPath, dependency, logger } = options;
    logger.warn(index_1.default.messages.cli.INSTALLING_DEPS(dependency, componentPath));
    const npmOptions = {
        dependency,
        installPath: componentPath,
        save: false,
        silent: true,
        usePrefix: false
    };
    const errorMsg = 'There was a problem while installing the compiler';
    try {
        await npm.installDependency(npmOptions);
        logger.ok('OK');
        const compiler = (0, clean_require_1.default)(compilerPath, { justTry: true });
        if (!(0, is_template_valid_1.default)(compiler)) {
            throw errorMsg;
        }
        return compiler;
    }
    catch (err) {
        logger.err('FAIL');
        throw errorMsg;
    }
}
