import type { Local } from '../domain/local';
import type { Logger } from '../logger';
declare const dev: ({ local, logger }: {
    logger: Logger;
    local: Local;
}) => {
    (opts: {
        prefix: string;
        dirPath: string;
        port?: number;
        baseUrl: string;
        fallbackRegistryUrl: string;
        hotReloading?: boolean;
        postRequestPayloadSize?: string;
        components?: string[];
        watch?: boolean;
        verbose?: boolean;
        production?: boolean;
    }): Promise<{
        close: (callback: (err?: Error | undefined | string) => void) => void | import("http").Server<typeof import("http").IncomingMessage, typeof import("http").ServerResponse>;
        on: <T extends keyof {
            error: {
                code: string;
                message: string;
            };
            start: unknown;
            'cache-poll': number;
            request: import("../../registry/domain/events-handler").RequestData;
            'component-retrieved': {
                headers: import("http").IncomingHttpHeaders;
                name: string;
                parameters: import("http").IncomingHttpHeaders;
                requestVersion: string;
                duration: number;
            };
            'data-provider-error': {
                name: string;
                version: string;
                parameters: Record<string, string | boolean | number>;
                requestVersion: string;
                status: number;
                error: Error;
            };
        }>(eventName: T, listener: (data: {
            error: {
                code: string;
                message: string;
            };
            start: unknown;
            'cache-poll': number;
            request: import("../../registry/domain/events-handler").RequestData;
            'component-retrieved': {
                headers: import("http").IncomingHttpHeaders;
                name: string;
                parameters: import("http").IncomingHttpHeaders;
                requestVersion: string;
                duration: number;
            };
            'data-provider-error': {
                name: string;
                version: string;
                parameters: Record<string, string | boolean | number>;
                requestVersion: string;
                status: number;
                error: Error;
            };
        }[T]) => void) => void;
        register: <T = any>(plugin: Omit<import("../../types").Plugin<T>, "callback">, callback?: ((...args: any[]) => void) | undefined) => void;
        start: (callback: (err: unknown, data?: {
            app: import("express").Express;
            server: import("http").Server;
        } | undefined) => void) => Promise<void>;
        app: import("express").Express;
    }>;
    (opts: {
        prefix: string;
        dirPath: string;
        port?: number;
        baseUrl: string;
        fallbackRegistryUrl: string;
        hotReloading?: boolean;
        postRequestPayloadSize?: string;
        components?: string[];
        watch?: boolean;
        verbose?: boolean;
        production?: boolean;
    }, arguments__1: (error: unknown, value: {
        close: (callback: (err?: Error | undefined | string) => void) => void | import("http").Server<typeof import("http").IncomingMessage, typeof import("http").ServerResponse>;
        on: <T extends keyof {
            error: {
                code: string;
                message: string;
            };
            start: unknown;
            'cache-poll': number;
            request: import("../../registry/domain/events-handler").RequestData;
            'component-retrieved': {
                headers: import("http").IncomingHttpHeaders;
                name: string;
                parameters: import("http").IncomingHttpHeaders;
                requestVersion: string;
                duration: number;
            };
            'data-provider-error': {
                name: string;
                version: string;
                parameters: Record<string, string | boolean | number>;
                requestVersion: string;
                status: number;
                error: Error;
            };
        }>(eventName: T, listener: (data: {
            error: {
                code: string;
                message: string;
            };
            start: unknown;
            'cache-poll': number;
            request: import("../../registry/domain/events-handler").RequestData;
            'component-retrieved': {
                headers: import("http").IncomingHttpHeaders;
                name: string;
                parameters: import("http").IncomingHttpHeaders;
                requestVersion: string;
                duration: number;
            };
            'data-provider-error': {
                name: string;
                version: string;
                parameters: Record<string, string | boolean | number>;
                requestVersion: string;
                status: number;
                error: Error;
            };
        }[T]) => void) => void;
        register: <T = any>(plugin: Omit<import("../../types").Plugin<T>, "callback">, callback?: ((...args: any[]) => void) | undefined) => void;
        start: (callback: (err: unknown, data?: {
            app: import("express").Express;
            server: import("http").Server;
        } | undefined) => void) => Promise<void>;
        app: import("express").Express;
    }) => void): void;
};
export default dev;
