import type { Logger } from './logger';
import dev from './facade/dev';
import init from './facade/init';
import mock from './facade/mock';
import packageScript from './facade/package';
import preview from './facade/preview';
import publish from './facade/publish';
import registryAdd from './facade/registry-add';
import registryLs from './facade/registry-ls';
import registryRemove from './facade/registry-remove';
type Options<T extends (...args: any) => any> = Parameters<ReturnType<T>>[0];
type Cb<T extends (...args: any) => any> = Parameters<ReturnType<T>>[1];
declare const _default: {
    dev: ({ logger, ...options }: Options<typeof dev> & {
        logger: Logger;
    }, cb: Cb<typeof dev>) => void;
    init: ({ logger, ...options }: Options<typeof init> & {
        logger: Logger;
    }, cb: Cb<typeof init>) => void;
    mock: ({ logger, ...options }: Options<typeof mock> & {
        logger: Logger;
    }, cb: Cb<typeof mock>) => void;
    package: ({ logger, ...options }: Options<typeof packageScript> & {
        logger: Logger;
    }, cb: Cb<typeof packageScript>) => void;
    publish: ({ logger, ...options }: Options<typeof publish> & {
        logger: Logger;
        registry?: string;
    }, cb: Cb<typeof publish>) => void;
    preview: ({ logger, ...options }: Options<typeof preview> & {
        logger: Logger;
        registry?: string;
    }, cb: Cb<typeof preview>) => void;
    registry: {
        add: ({ logger, ...options }: Options<typeof registryAdd> & {
            logger: Logger;
            registry?: string;
        }, cb: Cb<typeof registryAdd>) => void;
        ls: ({ logger, ...options }: Options<typeof registryLs> & {
            logger: Logger;
            registry?: string;
        }, cb: Cb<typeof registryLs>) => void;
        remove: ({ logger, ...options }: Options<typeof registryRemove> & {
            logger: Logger;
            registry?: string;
        }, cb: Cb<typeof registryRemove>) => void;
    };
};
export default _default;
