import http from 'node:http';
import express from 'express';
import type { Plugin } from '../types';
import { RegistryOptions } from './domain/options-sanitiser';
export { RegistryOptions };
export default function registry<T = any>(inputOptions: RegistryOptions<T>): {
    close: (callback: (err?: Error | undefined | string) => void) => void | http.Server<typeof http.IncomingMessage, typeof http.ServerResponse>;
    on: <T_1 extends keyof {
        error: {
            code: string;
            message: string;
        };
        start: unknown;
        'cache-poll': number;
        request: import("./domain/events-handler").RequestData;
        'component-retrieved': {
            headers: http.IncomingHttpHeaders;
            name: string;
            parameters: http.IncomingHttpHeaders;
            requestVersion: string;
            duration: number;
        };
        'data-provider-error': {
            name: string;
            version: string;
            parameters: Record<string, string | boolean | number>;
            requestVersion: string;
            status: number;
            error: Error;
        };
    }>(eventName: T_1, listener: (data: {
        error: {
            code: string;
            message: string;
        };
        start: unknown;
        'cache-poll': number;
        request: import("./domain/events-handler").RequestData;
        'component-retrieved': {
            headers: http.IncomingHttpHeaders;
            name: string;
            parameters: http.IncomingHttpHeaders;
            requestVersion: string;
            duration: number;
        };
        'data-provider-error': {
            name: string;
            version: string;
            parameters: Record<string, string | boolean | number>;
            requestVersion: string;
            status: number;
            error: Error;
        };
    }[T_1]) => void) => void;
    register: <T_1 = any>(plugin: Omit<Plugin<T_1>, "callback">, callback?: (...args: any[]) => void) => void;
    start: (callback: (err: unknown, data?: {
        app: express.Express;
        server: http.Server;
    }) => void) => Promise<void>;
    app: express.Express;
};
