"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = compress;
function compress(data, req, res) {
    const accept = req.headers['accept-encoding'];
    const encoding = typeof accept === 'string' &&
        (accept.match(/\bbr\b/) || accept.match(/\bgzip\b/) || [])[0];
    if (!encoding) {
        res.send(data.uncompressed);
        return;
    }
    res.setHeader('Content-Encoding', encoding);
    const compressed = encoding === 'br' ? data.brotli : data.gzip;
    res.send(compressed);
}
