"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = component;
const serialize_error_1 = require("serialize-error");
const node_stream_1 = require("node:stream");
const turbo_stream_1 = require("@rdevis/turbo-stream");
const resources_1 = __importDefault(require("../../resources"));
const get_component_1 = __importStar(require("./helpers/get-component"));
function component(conf, repository) {
    const getComponent = (0, get_component_1.default)(conf, repository);
    return (req, res) => {
        let parameters = req.query;
        if (req.method === 'POST') {
            parameters = {
                ...parameters,
                ...req.body
            };
        }
        getComponent({
            action: req.params['action'],
            conf: res.conf,
            headers: req.headers,
            ip: req.ip,
            name: req.params['componentName'],
            parameters,
            version: req.params['componentVersion']
        }, (result) => {
            if (result.response.error) {
                if (Object.prototype.toString.call(result.response.error) ===
                    '[object Error]') {
                    result.response.error = (0, serialize_error_1.serializeError)(result.response.error);
                }
                res.errorCode = result.response.code;
                res.errorDetails = result.response.error;
            }
            try {
                if (Object.keys(result.headers ?? {}).length) {
                    res.set(result.headers);
                }
                const streamEnabled = !!result.response.data?.component?.props?.[get_component_1.stream];
                if (streamEnabled) {
                    delete result.response.data.component.props[get_component_1.stream];
                    const webStream = (0, turbo_stream_1.encode)({ ...result.response });
                    const nodeStream = node_stream_1.Readable.from(webStream);
                    res.status(result.status);
                    nodeStream.on('error', (err) => {
                        res.status(500).end(String(err));
                    });
                    res.setHeader('Content-Type', 'x-text/stream');
                    nodeStream.pipe(res).on('finish', () => {
                        res.end();
                    });
                }
                else {
                    res.status(result.status).json(result.response);
                }
            }
            catch (e) {
                res.status(500).json({
                    code: 'RENDER_ERROR',
                    error: resources_1.default.errors.registry.RENDER_ERROR(`${result.response.name}@${result.response.version}`, String(e))
                });
            }
        });
    };
}
