"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = getAvailableDependencies;
const builtin_modules_1 = __importDefault(require("builtin-modules"));
const require_wrapper_1 = __importDefault(require("../../domain/require-wrapper"));
function getAvailableDependencies(dependencies) {
    return dependencies.map((dependency) => {
        const requirer = (0, require_wrapper_1.default)(dependencies);
        const core = builtin_modules_1.default.includes(dependency);
        const packageJson = !core
            ? requirer(`${dependency}/package.json`)
            : undefined;
        const version = packageJson?.version;
        const link = core
            ? `https://nodejs.org/api/${dependency}.html`
            : (packageJson?.homepage ?? '');
        return { core, name: dependency, version, link };
    });
}
