"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.getComponent = getComponent;
exports.getComponentPreview = getComponentPreview;
exports.getComponentInfo = getComponentInfo;
const undici_1 = require("undici");
const urlBuilder = __importStar(require("../../domain/url-builder"));
function getComponentFallbackForViewType(buildUrl, conf, req, res, registryError, callback) {
    const path = buildUrl({
        name: req.params['componentName'],
        version: req.params['componentVersion']
    }, conf.fallbackRegistryUrl);
    return (0, undici_1.request)(path, {
        method: 'GET',
        headers: {
            ...req.headers,
            host: new URL(conf.fallbackRegistryUrl).host,
            accept: 'application/json'
        }
    })
        .then((response) => {
        if (response.statusCode !== 200) {
            throw response;
        }
        return response.body.text();
    })
        .then((fallbackResponse) => {
        try {
            return callback(null, JSON.parse(fallbackResponse));
        }
        catch (parseError) {
            return callback({
                registryError: registryError,
                fallbackError: `Could not parse fallback response: ${fallbackResponse}`
            }, undefined);
        }
    })
        .catch(async (response) => {
        if (response.statusCode === 304) {
            return res.status(304).send('');
        }
        return callback({
            registryError: registryError,
            fallbackError: await response.body
                .text()
                .catch(() => response.statusCode)
        }, undefined);
    });
}
function getComponent(fallbackRegistryUrl, headers, component, callback) {
    // For some reason, undici doesn't like the content-type header
    const { 'content-type': _, ...restHeaders } = headers;
    (0, undici_1.request)(fallbackRegistryUrl, {
        method: 'POST',
        headers: {
            ...restHeaders,
            host: new URL(fallbackRegistryUrl).host,
            'Content-Type': 'application/json'
        },
        body: JSON.stringify({ components: [component] })
    })
        .then((response) => {
        if (response.statusCode !== 200) {
            throw response;
        }
        return response.body.json();
    })
        .then((res) => {
        if (!res || res.length === 0) {
            return callback({
                status: 404,
                response: {
                    code: 'NOT_FOUND',
                    error: 'Component not found'
                }
            });
        }
        return callback(res[0]);
    })
        .catch(async (err) => {
        return callback({
            status: 404,
            response: {
                code: 'NOT_FOUND',
                error: await err.body.text().catch(() => err.statusCode)
            }
        });
    });
}
function getComponentPreview(conf, req, res, registryError, callback) {
    getComponentFallbackForViewType(urlBuilder.componentPreview, conf, req, res, registryError, callback);
}
function getComponentInfo(conf, req, res, registryError, callback) {
    getComponentFallbackForViewType(urlBuilder.componentInfo, conf, req, res, registryError, callback);
}
