"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = isUrlDiscoverable;
const undici_1 = require("undici");
async function isUrlDiscoverable(url) {
    try {
        const res = await (0, undici_1.request)(url, { headers: { accept: 'text/html' } });
        const isHtml = !!res.headers['content-type']?.includes('text/html');
        return {
            isDiscoverable: isHtml
        };
    }
    catch (err) {
        return { isDiscoverable: false };
    }
}
