"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = staticRedirector;
const node_path_1 = __importDefault(require("node:path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const storageUtils = __importStar(require("oc-storage-adapters-utils"));
const compression_1 = __importDefault(require("../middleware/compression"));
function staticRedirector(repository) {
    return (req, res) => {
        let filePath;
        const clientPath = `${res.conf.prefix || '/'}oc-client/client.js`;
        const devClientPath = `${res.conf.prefix || '/'}oc-client/client.dev.js`;
        const clientMapPath = `${res.conf.prefix || '/'}oc-client/oc-client.min.map`;
        if (req.route.path === clientPath || req.route.path === devClientPath) {
            if (res.conf.local) {
                if (res.conf.compiledClient) {
                    res.type('application/javascript');
                    res.send(res.conf.compiledClient.dev);
                    return;
                }
                filePath = node_path_1.default.join(__dirname, '../../components/oc-client/_package/src/oc-client.js');
            }
            else {
                if (res.conf.compiledClient) {
                    res.type('application/javascript');
                    if (req.route.path === clientPath) {
                        (0, compression_1.default)({
                            uncompressed: res.conf.compiledClient.code.minified,
                            brotli: res.conf.compiledClient.code.brotli,
                            gzip: res.conf.compiledClient.code.gzip
                        }, req, res);
                    }
                    else {
                        res.send(res.conf.compiledClient.dev);
                    }
                    return;
                }
                res.redirect(repository.getStaticClientPath(req.route.path === devClientPath));
                return;
            }
        }
        else if (req.route.path === clientMapPath) {
            if (res.conf.local) {
                filePath = node_path_1.default.join(__dirname, '../../components/oc-client/_package/src/oc-client.min.map');
            }
            else {
                if (res.conf.compiledClient) {
                    res.type('text/plain');
                    res.send(res.conf.compiledClient.map);
                    return;
                }
                res.redirect(repository.getStaticClientMapPath());
                return;
            }
        }
        else if (req.params['componentName'] === 'oc-client') {
            filePath = node_path_1.default.join(__dirname, '../../components/oc-client/_package/' + req.params[0]);
        }
        else {
            filePath =
                node_path_1.default.join(res.conf.path, req.params['componentName']) +
                    '/_package/' +
                    req.params[0];
        }
        if (!fs_extra_1.default.existsSync(filePath)) {
            res.errorDetails = `File ${filePath} not found`;
            res.status(404).json({ err: res.errorDetails });
            return;
        }
        const stats = fs_extra_1.default.statSync(filePath);
        if (stats.isDirectory()) {
            res.errorDetails = 'Forbidden: Directory Listing Denied';
            res.status(403).json({ err: res.errorDetails });
            return;
        }
        const fileStream = fs_extra_1.default.createReadStream(filePath);
        const fileInfo = storageUtils.getFileInfo(filePath);
        if (fileInfo.mimeType) {
            res.set('Content-Type', fileInfo.mimeType);
        }
        if (fileInfo.gzip) {
            res.set('Content-Encoding', 'gzip');
        }
        fileStream.on('open', () => {
            fileStream.pipe(res);
        });
    };
}
