"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_path_1 = __importDefault(require("node:path"));
const form_data_1 = __importDefault(require("form-data"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const undici_1 = require("undici");
async function put(urlPath, files, headers) {
    const form = new form_data_1.default();
    if (!Array.isArray(files)) {
        files = [files];
    }
    for (const file of files) {
        const fileName = node_path_1.default.basename(file);
        form.append(fileName, fs_extra_1.default.createReadStream(file));
    }
    const res = await (0, undici_1.request)(urlPath, {
        headers: { ...headers, ...form.getHeaders() },
        method: 'PUT',
        body: form
    });
    const response = await res.body.text();
    if (res.statusCode !== 200) {
        throw response;
    }
    return response;
}
exports.default = put;
